searchData={"items":[{"type":"module","title":"Beethoven","doc":"A Decentralized failover and peer-to-peer node finder for Elixir.\nAllows Elixir nodes to find each other automatically.\nOnce connected, they can coordinate to delegate roles and tasks between the nodes in the cluster.\nWritten using only the Elixir and Erlang standard library.\n\nThis module acts as the unified client for interacting with beethoven as an external client.\nAvoid using the other modules for external PID calls to beethoven services.","ref":"Beethoven.html"},{"type":"function","title":"Beethoven.kill_node/0","doc":"Kills the an Elixir/Erlang application running Beethoven.","ref":"Beethoven.html#kill_node/0"},{"type":"module","title":"Beethoven.Az","doc":"Azure Platform awareness for the node.\nIf the app is not in Azure, genserver will response `:no_azure` to all calls.","ref":"Beethoven.Az.html"},{"type":"function","title":"Beethoven.Az.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Beethoven.Az.html#child_spec/1"},{"type":"function","title":"Beethoven.Az.get_AzRegion/0","doc":"Retrieves the Azure region from IMDS data.","ref":"Beethoven.Az.html#get_AzRegion/0"},{"type":"function","title":"Beethoven.Az.get_AzSubnet/0","doc":"Retrieves the VM's networking config from IMDS data.\n\n**RETURNS ONLY PRIMARY INT FOR VM**","ref":"Beethoven.Az.html#get_AzSubnet/0"},{"type":"function","title":"Beethoven.Az.get_state/0","doc":"Retrieves the Azure region from IMDS data.","ref":"Beethoven.Az.html#get_state/0"},{"type":"function","title":"Beethoven.Az.start_link/1","doc":"Entry point for Supervisors. Links calling PID this this child pid.","ref":"Beethoven.Az.html#start_link/1"},{"type":"module","title":"Beethoven.Az.Lib","doc":"Library for Az Genserver","ref":"Beethoven.Az.Lib.html"},{"type":"function","title":"Beethoven.Az.Lib.call_IMDS/0","doc":"Calls IMDS to get metadata about this VM.\nA response of `{:error, :timeout}` indicates that you are not in Azure.\nIMDS should never go down or be unreachable outside of a live-site outage.","ref":"Beethoven.Az.Lib.html#call_IMDS/0"},{"type":"function","title":"Beethoven.Az.Lib.get_AzRegion/1","doc":"Gets the VM's Azure region from cached IMDS data.","ref":"Beethoven.Az.Lib.html#get_AzRegion/1"},{"type":"function","title":"Beethoven.Az.Lib.get_AzSubnet/1","doc":"Gets the VM's networking config from cached IMDS data.","ref":"Beethoven.Az.Lib.html#get_AzSubnet/1"},{"type":"module","title":"Beethoven.Core","doc":"Core of Coordinator service. This is the primary GenServer for the service.","ref":"Beethoven.Core.html"},{"type":"function","title":"Beethoven.Core.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Beethoven.Core.html#child_spec/1"},{"type":"function","title":"Beethoven.Core.start_link/1","doc":"Entry point for Supervisors. Links calling PID this this child pid.","ref":"Beethoven.Core.html#start_link/1"},{"type":"module","title":"Beethoven.Core.Client","doc":"Client library for accessing or interacting with the `Beethoven.Core` server.","ref":"Beethoven.Core.Client.html"},{"type":"function","title":"Beethoven.Core.Client.start_shutdown/0","doc":"Kills Beethoven Core and dependency tree gracefully.","ref":"Beethoven.Core.Client.html#start_shutdown/0"},{"type":"function","title":"Beethoven.Core.Client.to_clustered/0","doc":"Triggers a clustered transition for `Beethoven.Core`.\nReturns `:noop` if Core Server is already in the desired state.","ref":"Beethoven.Core.Client.html#to_clustered/0"},{"type":"function","title":"Beethoven.Core.Client.to_standalone/0","doc":"Triggers a standalone transition for `Beethoven.Core`.\nReturns `:noop` if Core Server is already in the desired state.","ref":"Beethoven.Core.Client.html#to_standalone/0"},{"type":"module","title":"Beethoven.Core.Listener","doc":"Genserver/TCP listener used to help Beethoven instances find each other.","ref":"Beethoven.Core.Listener.html"},{"type":"function","title":"Beethoven.Core.Listener.accept/1","doc":"TCP accept loop. When server gets a request","ref":"Beethoven.Core.Listener.html#accept/1"},{"type":"function","title":"Beethoven.Core.Listener.async_start/0","doc":"Starts server as a child of the root supervisor.\nOperation runs from a task to avoid hanging the caller waiting for init.","ref":"Beethoven.Core.Listener.html#async_start/0"},{"type":"function","title":"Beethoven.Core.Listener.async_timed_start/0","doc":"Starts server as a child of the root supervisor.\nOperation runs from a task to avoid hanging the caller waiting for init.\n(random number between 2.5-5.75 seconds)","ref":"Beethoven.Core.Listener.html#async_timed_start/0"},{"type":"function","title":"Beethoven.Core.Listener.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Beethoven.Core.Listener.html#child_spec/1"},{"type":"function","title":"Beethoven.Core.Listener.start_link/1","doc":"Entry point for Supervisors. Links calling PID this this child pid.","ref":"Beethoven.Core.Listener.html#start_link/1"},{"type":"module","title":"Beethoven.Core.Locator","doc":"Library module for finding a Beethoven listener within a target network.","ref":"Beethoven.Core.Locator.html"},{"type":"function","title":"Beethoven.Core.Locator.try_join/2","doc":"Attempts join to a Beethoven Listener Socket server hosted on another Elixir node.\nUsing the provided socket info, the client will attempt to connect to the socket and deliver its node uri as a payload.","ref":"Beethoven.Core.Locator.html#try_join/2"},{"type":"function","title":"Beethoven.Core.Locator.try_join_iter/2","doc":"Iterates through a list of IPs and tries to find one running a Beethoven Listener.\nSame returns as `try_join/2`.","ref":"Beethoven.Core.Locator.html#try_join_iter/2"},{"type":"module","title":"Beethoven.Core.MnesiaNotify","doc":"Library to reduce code length of Core server.\nOnly handles `hand_info` messages about Mnesia changes.","ref":"Beethoven.Core.MnesiaNotify.html"},{"type":"function","title":"Beethoven.Core.MnesiaNotify.new_node/1","doc":"Logic when a new node is added to the 'Beethoven.Tracker' table / Cluster","ref":"Beethoven.Core.MnesiaNotify.html#new_node/1"},{"type":"function","title":"Beethoven.Core.MnesiaNotify.offline_node/1","doc":"Node changed from online to offline in 'Beethoven.Tracker' table","ref":"Beethoven.Core.MnesiaNotify.html#offline_node/1"},{"type":"function","title":"Beethoven.Core.MnesiaNotify.online_node/1","doc":"Node changed from offline to online in 'Beethoven.Tracker' table","ref":"Beethoven.Core.MnesiaNotify.html#online_node/1"},{"type":"function","title":"Beethoven.Core.MnesiaNotify.run/1","doc":"Entry function to decide what is done when the Mnesia Event occurs.","ref":"Beethoven.Core.MnesiaNotify.html#run/1"},{"type":"module","title":"Beethoven.Core.Node","doc":"Library to reduce code length of Core server.\nOnly handles `hand_info` messages about Monitored node health.","ref":"Beethoven.Core.Node.html"},{"type":"function","title":"Beethoven.Core.Node.down/1","doc":"Handles what happens when a node goes down.","ref":"Beethoven.Core.Node.html#down/1"},{"type":"module","title":"Beethoven.Core.Startup","doc":"Library for service startup. Handles Seeking of other nodes.","ref":"Beethoven.Core.Startup.html"},{"type":"function","title":"Beethoven.Core.Startup.start_seeking/1","doc":"Starts seeking for other nodes within the current node's network","ref":"Beethoven.Core.Startup.html#start_seeking/1"},{"type":"module","title":"Beethoven.Core.Transition","doc":"Library to reduce code length of Core server.\nHandles logic for mode transitions","ref":"Beethoven.Core.Transition.html"},{"type":"function","title":"Beethoven.Core.Transition.start_servers/0","doc":"Starts all 3 dependant services for `Beethoven.Core`","ref":"Beethoven.Core.Transition.html#start_servers/0"},{"type":"function","title":"Beethoven.Core.Transition.transition/2","doc":"","ref":"Beethoven.Core.Transition.html#transition/2"},{"type":"module","title":"Beethoven.Ipv4","doc":"Module to handle scanning IPV4 addresses within a network.","ref":"Beethoven.Ipv4.html"},{"type":"function","title":"Beethoven.Ipv4.get_host_network_addresses/0","doc":"Retrieves the hosts IP address. Pulls Network and Netmask from the config.","ref":"Beethoven.Ipv4.html#get_host_network_addresses/0"},{"type":"function","title":"Beethoven.Ipv4.get_host_network_addresses/2","doc":"Same as get_host_network_addresses/0 but works off provided network and netmask.","ref":"Beethoven.Ipv4.html#get_host_network_addresses/2"},{"type":"function","title":"Beethoven.Ipv4.get_hosts/2","doc":"Generates a list of hosts with the network and netmask provided","ref":"Beethoven.Ipv4.html#get_hosts/2"},{"type":"function","title":"Beethoven.Ipv4.get_netmask_hosts/1","doc":"Gets the number of IPs within a netmask.","ref":"Beethoven.Ipv4.html#get_netmask_hosts/1"},{"type":"function","title":"Beethoven.Ipv4.increment_ip/1","doc":"Increments IP by one host.","ref":"Beethoven.Ipv4.html#increment_ip/1"},{"type":"module","title":"Beethoven.Role","doc":"Handles role re/assignment between clusters.","ref":"Beethoven.Role.html"},{"type":"function","title":"Beethoven.Role.async_start/0","doc":"Starts server as a child of the root supervisor.\nOperation runs from a task to avoid hanging the caller waiting for init.","ref":"Beethoven.Role.html#async_start/0"},{"type":"function","title":"Beethoven.Role.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Beethoven.Role.html#child_spec/1"},{"type":"function","title":"Beethoven.Role.handle_call/3","doc":"Kills all roles on the server","ref":"Beethoven.Role.html#handle_call/3"},{"type":"function","title":"Beethoven.Role.start_link/1","doc":"Entry point for Supervisors. Links calling PID this this child pid.","ref":"Beethoven.Role.html#start_link/1"},{"type":"module","title":"Beethoven.Role.Client","doc":"Client library for accessing and communicating with the Role Server.","ref":"Beethoven.Role.Client.html"},{"type":"function","title":"Beethoven.Role.Client.add_role/1","doc":"Adds a role to the Role server. Role must already be defined in the config.","ref":"Beethoven.Role.Client.html#add_role/1"},{"type":"function","title":"Beethoven.Role.Client.add_role_remote/3","doc":"Adds a role to the Role server. Role must already be defined in the config.\nThe same as `add_role/1` but ran on an external node.","ref":"Beethoven.Role.Client.html#add_role_remote/3"},{"type":"function","title":"Beethoven.Role.Client.kill_all_roles/0","doc":"Removes all roles from the Role server.","ref":"Beethoven.Role.Client.html#kill_all_roles/0"},{"type":"function","title":"Beethoven.Role.Client.kill_all_roles_remote/2","doc":"Removes all roles from the Role server.\nThe same as `kill_all_roles/0` but ran on an external node.","ref":"Beethoven.Role.Client.html#kill_all_roles_remote/2"},{"type":"function","title":"Beethoven.Role.Client.kill_role/1","doc":"Removes a role from the Role server.","ref":"Beethoven.Role.Client.html#kill_role/1"},{"type":"function","title":"Beethoven.Role.Client.kill_role_remote/3","doc":"Removes a role from the Role server.\nThe same as `kill_role/1` but ran on an external node.","ref":"Beethoven.Role.Client.html#kill_role_remote/3"},{"type":"module","title":"Beethoven.RoleAlloc","doc":"Role Allocation Server. Works as a queue to assign roles needed by the configuration.\n\n# TODO\n- Fix bug where a node goes down, but comes back up before it is updated in tracker\n  ex: Node (nodeY@127.0.0.1) is back online\n  Potential solutions\n  - a task that waits and calls the role alloc server back to let it know if it needs to remove the node or not?","ref":"Beethoven.RoleAlloc.html"},{"type":"function","title":"Beethoven.RoleAlloc.async_start/0","doc":"Starts server as a child of the root supervisor.\nOperation runs from a task to avoid hanging the caller waiting for init.","ref":"Beethoven.RoleAlloc.html#async_start/0"},{"type":"function","title":"Beethoven.RoleAlloc.async_timed_start/0","doc":"Starts server as a child of the root supervisor.\nOperation runs from a task to avoid hanging the caller waiting for init.\n(random number between 2.5-5.75 seconds)","ref":"Beethoven.RoleAlloc.html#async_timed_start/0"},{"type":"function","title":"Beethoven.RoleAlloc.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Beethoven.RoleAlloc.html#child_spec/1"},{"type":"function","title":"Beethoven.RoleAlloc.start_link/1","doc":"Entry point for Supervisors. Links calling PID this this child pid.","ref":"Beethoven.RoleAlloc.html#start_link/1"},{"type":"module","title":"Beethoven.RoleAlloc.Client","doc":"Client Library for interacting with the RoleAlloc Server","ref":"Beethoven.RoleAlloc.Client.html"},{"type":"function","title":"Beethoven.RoleAlloc.Client.prune/2","doc":"Instructs RoleAlloc Server to mark the provided node offline and start reassignment of its roles.\nDefaults to using the nodeName of the caller unless specified.","ref":"Beethoven.RoleAlloc.Client.html#prune/2"},{"type":"function","title":"Beethoven.RoleAlloc.Client.start_assign/0","doc":"Starts Assignment loop on the RoleAlloc Server in the cluster.\nAssumes RoleServer is running locally.","ref":"Beethoven.RoleAlloc.Client.html#start_assign/0"},{"type":"function","title":"Beethoven.RoleAlloc.Client.start_cleanup/0","doc":"Starts clean up job on the RoleAlloc Server in the cluster.\nAssumes RoleServer is running locally.","ref":"Beethoven.RoleAlloc.Client.html#start_cleanup/0"},{"type":"function","title":"Beethoven.RoleAlloc.Client.timed_assign/1","doc":"Same as `start_assign/0` but has a defined sleep before sending the cast.\nJob is done in a task to avoid hanging thread","ref":"Beethoven.RoleAlloc.Client.html#timed_assign/1"},{"type":"function","title":"Beethoven.RoleAlloc.Client.timed_cleanup/1","doc":"Same as `start_cleanup/0` but has a defined sleep before sending the cast.\nJob is done in a task to avoid hanging thread","ref":"Beethoven.RoleAlloc.Client.html#timed_cleanup/1"},{"type":"module","title":"Beethoven.RoleAlloc.Lib","doc":"Library module for RoleAlloc server.","ref":"Beethoven.RoleAlloc.Lib.html"},{"type":"function","title":"Beethoven.RoleAlloc.Lib.get_max_retries/1","doc":"Gets the maximum number of retries possible.\nBased on `total roles to assign * number of nodes` in the cluster via `Node.list/0`.\n\nIf result equals <4 output value will be 4.","ref":"Beethoven.RoleAlloc.Lib.html#get_max_retries/1"},{"type":"function","title":"Beethoven.RoleAlloc.Lib.get_new_retries/1","doc":"Makes fresh retries tuple.\nretries have 4 categories\n0 -> Role retries\n1 -> Total retries\n2 -> Max Role retries (# of nodes via Node.list/0)\n3 -> Max Total Retries (all roles * all hosts)","ref":"Beethoven.RoleAlloc.Lib.html#get_new_retries/1"},{"type":"function","title":"Beethoven.RoleAlloc.Lib.get_open_roles/1","doc":"Takes input role map and provides a list of roles needed based on current roles hosted in the cluster.","ref":"Beethoven.RoleAlloc.Lib.html#get_open_roles/1"},{"type":"function","title":"Beethoven.RoleAlloc.Lib.make_host_queue/0","doc":"Generates a new host queue based on how many roles the nodes have.\nLess roles == higher priority in the queue.","ref":"Beethoven.RoleAlloc.Lib.html#make_host_queue/0"},{"type":"function","title":"Beethoven.RoleAlloc.Lib.role_map_to_list/1","doc":"Takes the input role map and outputs a list of roles.\nUses the instance value for each role to create `n` amount of roles in the list as needed,","ref":"Beethoven.RoleAlloc.Lib.html#role_map_to_list/1"},{"type":"module","title":"Beethoven.RoleAlloc.MnesiaNotify","doc":"Library to simplify handling Mnesia events","ref":"Beethoven.RoleAlloc.MnesiaNotify.html"},{"type":"function","title":"Beethoven.RoleAlloc.MnesiaNotify.run/4","doc":"Entry function to decide what is done when the Mnesia Event occurs.","ref":"Beethoven.RoleAlloc.MnesiaNotify.html#run/4"},{"type":"module","title":"Beethoven.TestRole","doc":"Test role to test RoleServer operations.\n\nA role is just another PID of some kind. Module must have `start_link/1` that returns {:ok, pid()} or the role will fail to load.","ref":"Beethoven.TestRole.html"},{"type":"function","title":"Beethoven.TestRole.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Beethoven.TestRole.html#child_spec/1"},{"type":"function","title":"Beethoven.TestRole.start_link/1","doc":"Entry point for RolServer/Supervisor","ref":"Beethoven.TestRole.html#start_link/1"},{"type":"module","title":"Beethoven.Tracker","doc":"Module to handle the `Beethoven.Tracker` mnesia table.\nThis table is used by beethoven to track the state and roles of nodes within the cluster.","ref":"Beethoven.Tracker.html"},{"type":"function","title":"Beethoven.Tracker.add_role/2","doc":"Add role to a node.","ref":"Beethoven.Tracker.html#add_role/2"},{"type":"function","title":"Beethoven.Tracker.add_self/1","doc":"Adds self to BeethovenTracking Mnesia table.\nUses a record like this:\n\n`\n{Tracker, node(), roles, :online, DateTime.now!(\"Etc/UTC\")}\n`","ref":"Beethoven.Tracker.html#add_self/1"},{"type":"function","title":"Beethoven.Tracker.builtin_roles/0","doc":"List of builtin roles used for filtering.","ref":"Beethoven.Tracker.html#builtin_roles/0"},{"type":"function","title":"Beethoven.Tracker.clear_offline_roles/0","doc":"Clear all roles from offline nodes. Returns list of roles cleared.","ref":"Beethoven.Tracker.html#clear_offline_roles/0"},{"type":"function","title":"Beethoven.Tracker.clear_roles/1","doc":"Clear all roles from a node.","ref":"Beethoven.Tracker.html#clear_roles/1"},{"type":"function","title":"Beethoven.Tracker.find_work/1","doc":"Compares a list of roles to what is hosted in the Tracker.\nReturns roles that are not hosted in Mnesia, but provided in the argument.\nDuplicate inputs are allowed and encouraged.","ref":"Beethoven.Tracker.html#find_work/1"},{"type":"function","title":"Beethoven.Tracker.get_active_roles/0","doc":"Gets roles hosted in the cluster. Provides list of roles - this list is **not** deduplicated.","ref":"Beethoven.Tracker.html#get_active_roles/0"},{"type":"function","title":"Beethoven.Tracker.get_active_roles_by_host/0","doc":"Gets the count of roles held by each node.\nProvides a list of lists, where each nested list is data from a single record in mnesia.","ref":"Beethoven.Tracker.html#get_active_roles_by_host/0"},{"type":"function","title":"Beethoven.Tracker.get_inactive_roles/0","doc":"Gets roles hosted in the cluster by offline nodes. Provides list of roles - this list is **not** deduplicated.","ref":"Beethoven.Tracker.html#get_inactive_roles/0"},{"type":"function","title":"Beethoven.Tracker.is_host_running_role?/2","doc":"Checks if a role is hosted on a given node.","ref":"Beethoven.Tracker.html#is_host_running_role?/2"},{"type":"function","title":"Beethoven.Tracker.is_role_hosted?/1","doc":"Checks if a role is hosted in the cluster.\nDoes not return truthful if the hosting node is offline.","ref":"Beethoven.Tracker.html#is_role_hosted?/1"},{"type":"function","title":"Beethoven.Tracker.join/0","doc":"Joins the `Beethoven.Tracker` mnesia table as a cluster node.","ref":"Beethoven.Tracker.html#join/0"},{"type":"function","title":"Beethoven.Tracker.remove_builtins/1","doc":"Removes builtin roles from a list of roles provided to the function.","ref":"Beethoven.Tracker.html#remove_builtins/1"},{"type":"function","title":"Beethoven.Tracker.remove_role/2","doc":"Remove role from a node.","ref":"Beethoven.Tracker.html#remove_role/2"},{"type":"function","title":"Beethoven.Tracker.set_node_offline/1","doc":"Sets node in tracker offline. Also clears roles on the node.","ref":"Beethoven.Tracker.html#set_node_offline/1"},{"type":"function","title":"Beethoven.Tracker.start/0","doc":"Starts `Beethoven.Tracker` Mnesia table","ref":"Beethoven.Tracker.html#start/0"},{"type":"function","title":"Beethoven.Tracker.subscribe/0","doc":"Subscribe to changes to the BeethovenTracking Mnesia table.","ref":"Beethoven.Tracker.html#subscribe/0"},{"type":"module","title":"Beethoven.Utils","doc":"Module for generic utilities.","ref":"Beethoven.Utils.html"},{"type":"function","title":"Beethoven.Utils.backoff/3","doc":"Performs a backoff wait to void race conditions in a distributed environment.\n(:rand.uniform(1 - max) + delta) * multiplier","ref":"Beethoven.Utils.html#backoff/3"},{"type":"function","title":"Beethoven.Utils.backoff_n/4","doc":"The same as `backoff/3` but shows the calling service's name in the verbose output.\n\nPerforms a backoff wait to void race conditions in a distributed environment.\n(:rand.uniform(1 - max) + delta) * multiplier","ref":"Beethoven.Utils.html#backoff_n/4"},{"type":"function","title":"Beethoven.Utils.copy_mnesia_table/1","doc":"Copies desired table to local node memory.\n- Table must already exist in the cluster.\n- If the table was initialized on this node, the table is already in memory.\n- If node successfully joined in the past, but power-cycled, rebooting will automatically grab the tables from the cluster.","ref":"Beethoven.Utils.html#copy_mnesia_table/1"},{"type":"function","title":"Beethoven.Utils.get_app_env/2","doc":"Gets an environmental variable from beethoven's application config","ref":"Beethoven.Utils.html#get_app_env/2"},{"type":"function","title":"Beethoven.Utils.get_role_config/0","doc":"Retrieves roles from config and converts to map.","ref":"Beethoven.Utils.html#get_role_config/0"},{"type":"function","title":"Beethoven.Utils.mnesia_table_exists?/1","doc":"Check if Mnesia table exists","ref":"Beethoven.Utils.html#mnesia_table_exists?/1"},{"type":"function","title":"Beethoven.Utils.monitor_all_nodes/1","doc":"Toggles the monitoring status of **all** nodes in the cluster.","ref":"Beethoven.Utils.html#monitor_all_nodes/1"},{"type":"function","title":"Beethoven.Utils.monitor_node/2","doc":"Toggles the monitoring status of another node in the cluster.","ref":"Beethoven.Utils.html#monitor_node/2"},{"type":"function","title":"Beethoven.Utils.remote_call/3","doc":"Fn to simplify calling named Processes on other nodes... and getting a call back.","ref":"Beethoven.Utils.html#remote_call/3"},{"type":"function","title":"Beethoven.Utils.role_list_to_map/1","doc":"Creates a map from a list of maps. First element of the map needs to be an atom.\nThis same atom will be the key for the rest of the data in the map.","ref":"Beethoven.Utils.html#role_list_to_map/1"},{"type":"function","title":"Beethoven.Utils.sync_run/1","doc":"Runs a job within a synchronous transaction","ref":"Beethoven.Utils.html#sync_run/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}